import sys
import traceback
from browser import document, timer, alert

TURTLE_PREFIX = '''
from browser import document
import turtle
turtle.set_defaults(
    turtle_canvas_wrapper = document['turtle_box']
)
'''

TURTLE_END = '''
turtle.done()
'''

RUNNING = False

FIRST_TIME = True
def inform(*args):
    pass
    #document["output"].html = "".join(args)
    
def _write(*args):
    document["output"].html += "".join(args)
def __write(*args):
    document["output"].html += '<span class="error">' + "".join(args) + "</span>"

sys.stdout.write = _write
sys.stderr.write = __write

def clear_print():
    document["output"].html = ""

def run_code(ev):
    clear(ev)
    global RUNNING
    if RUNNING:
        return
    RUNNING = True
    global FIRST_TIME
    if FIRST_TIME:
        FIRST_TIME = False
        inform("Importing turtle module for the first time and processing; please wait")
    else:
        inform("Processing")
    # document["run"].class_name = "btn-disabled"
    # delay to allow updated DOM with above text to be shown.
    # exec_code()
    timer.set_timeout(exec_code, 1)

document["run"].bind("click", run_code)

def exec_code():
    _code= document["code_txt"].value
    global RUNNING
    if 'turtle' in _code:
        _code = TURTLE_PREFIX + _code
        if 'turtle.done()' not in _code:
            _code = _code + TURTLE_END
    try:
        exec(_code)
        RUNNING = False
    except:
        RUNNING = False
        try:
            traceback.print_exc()
        except:
            print("could not print traceback")
    # document["clear"].class_name = "btn-enabled"
    inform("")

def delayed_clear():
    from turtle import restart
    restart()
    inform("")
    # document["run"].class_name = "btn-enabled"
    # document["clear"].class_name = "btn-disabled"
    clear_print()

def clear(ev):
    global RUNNING
    RUNNING = False

    global FIRST_TIME
    if FIRST_TIME:
        FIRST_TIME = False
        inform("Importing turtle module for the first time and processing; please wait")
        document["run"].class_name = "btn-disabled"
    # delay to allow updated DOM with above text to be shown.
    timer.set_timeout(delayed_clear, 1)

document["clear"].bind("click", clear)

def replay(ev):
    # importing turtle earlier slows down the loading
    # of this page
    from turtle import replay_scene
    replay_scene()
        